﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;

using Infragistics.WebUI.WebSchedule;

namespace ScheduleMountain
{
    public class Fixtures : Infragistics.WebUI.WebSchedule.Appointment
    {
        public Fixtures(WebScheduleInfo westBromwichAlbion)
            : base(westBromwichAlbion)
        {
            try
            {
                this.ID = DateTime.Now.Millisecond;
            }
            catch (Exception ex)
            {
                System.Diagnostics.Debug.WriteLine(ex.Message);
            }
        }

        public Fixtures(//int id,
                        DateTime startDateTimeUtc,
                        int duration,
                        //string subject,
                        bool allDayEvent,
                        string location,
                        //string description,
                        string homeTeam,
                        string visitors,
                        int status,
                        bool enableReminders,
                        int showTimeAs,
                        int importance,
                        string varianceID,
                        string recurrencePattern,
                        int recurrenceID,
                        object originalStartDateTimeUtc,
                        string resourceKey,
                        WebScheduleInfo wba
            )
            : this(wba)
        {
            StartDateTimeUtc = startDateTimeUtc;
            Duration = duration;
            //Subject = subject;
            AllDayEvent = allDayEvent;
            //Location = location;
            this.HomeTeam = homeTeam;
            this.Visitors = visitors;
            //Description = description;
            Status = status;
            EnableReminders = enableReminders;
            ShowTimeAs = showTimeAs;
            Importance = importance;
            VarianceID = varianceID;
            RecurrencePattern = recurrencePattern;
            RecurrenceID = recurrenceID;
            OriginalStartDateTimeUtc = originalStartDateTimeUtc as DateTime?;
            ResourceKey = resourceKey;
        }

        private string _typeIconPath;
        public string TYPEICONPATH
        {
            get { return this._typeIconPath; }
            set { this._typeIconPath = value; }
        }


        public DateTime StartDateTimeUtc
        {
            get
            {
                return this.GameDate; //.ToUniversalTime();
            }
            set
            {
                this.GameDate = value;
            }
        }

        private DateTime? _originalStartDateTimeUtc;

        public DateTime? OriginalStartDateTimeUtc
        {
            get
            {
                return this._originalStartDateTimeUtc; //.ToUniversalTime();
            }
            set
            {
                this._originalStartDateTimeUtc = value;
            }
        }

        public int Duration { get { return this.GameDuration; } set { this.GameDuration = value; } }

        public DateTime GameDate { get; set; }
        public string HomeTeam { get; set; }
        public string Visitors { get; set; }
        public int GameDuration { get; set; }

        public int ID { get; set; }

        private string _name;
        public string Name // aka Subject
        {
            get { return this.Visitors + " @ " + this.HomeTeam; }
            set { this._name = value;  }
        }

        public string Description
        {
            get { return this.Name; }
            set { this.Name = value;  }
        }

        public string Subject
        {
            get { return this.Name; }
            set { this.Name = value;  }
        }

        private bool _allDayEvent;
        public bool AllDayEvent
        {
            get { return this._allDayEvent; }
            set
            {
                this._allDayEvent = value;
            }
        }

        private string _location = string.Empty;
        public string Location
        {
            get
            {
                if (this._location == string.Empty && this.HomeTeam != string.Empty && Fixtures.Stadiums.ContainsKey(this.HomeTeam))
                {
                    this._location = Fixtures.Stadiums[this.HomeTeam];
                }
                return this._location;
            }
            set
            {
                this._location = value;
            }
        }

        private string ActivityDescription
        {
            get { return this.Name;  }
        }

        private int _status;
        public int Status
        {
            get
            {
                return this._status;
            }
            set
            {
                this._status = value;
            }
        }

        private bool _enableReminders;
        public bool EnableReminders
        {
            get { return this._enableReminders; }
            set { this._enableReminders = value; }
        }

        private int _showTimeAs;
        public int ShowTimeAs
        {
            get { return this._showTimeAs; }
            set { this._showTimeAs = value;  }
        }


        private int _importance;
        public int Importance
        {
            get { return this._importance; }
            set { this._importance = value; }
        }

        private string _resourceKey = "0";
        public string ResourceKey
        {
            get { return _resourceKey; }
            set
            {
                _resourceKey = value;
            }
        }

        private int _recurrenceID;
        public int RecurrenceID
        {
            get { return _recurrenceID; }
            set
            {
                _recurrenceID = value;
            }
        }


        private string _recurrencePattern;
        public string RecurrencePattern
        {
            get { return _recurrencePattern; }
            set
            {
                _recurrencePattern = value;
            }
        }

        private int ReminderInterval { get { return 0;  } }

        private string _varianceID;
        public string VarianceID
        {
            get { return this._varianceID; }
            set { this._varianceID = value; }
        }

        public static string[] Teams = new string[] {
            "Chelsea",
            "Arsenal",
            "Manchester City",
            "Manchester United",
            "Liverpool",
            "Tottenham Hotspur",
            "Southampton",
            "Newcastle United",
            "Everton",
            "West Ham United",
            "Swansea City",
            "West Bromwich Albion",
            "Hull City",
            "Leicester City",
            "Crystal Palace",
            "Queens Park Rangers",
            "Burnley",
            "Sunderland",
            "Stoke City",
            "Aston Villa"
        };

        public static Dictionary<string, string> Stadiums = new Dictionary<string, string>()
        {
            { "Chelsea", "Stamford Bridge"},
            { "Arsenal", "The Emirates"},
            { "Manchester City", "The Etihad"},
            { "Manchester United", "Old Trafford"},
            { "Liverpool", "Anfield"},
            { "Tottenham Hotspur", "White Hart Lane"},
            { "Southampton", "St. Marys"},
            { "Newcastle United", "St. James' Park"},
            { "Everton", "Goodison Park"},
            { "West Ham United", "The Boleyn Ground"},
            { "Swansea City", "Liberty Stadium"},
            { "West Bromwich Albion", "The Hawthorns"},
            { "Hull City", "KC Stadium"},
            { "Leicester City", "King Power Stadium"},
            { "Crystal Palace", "Selhurst Park"},
            { "Queens Park Rangers", "Loftus Road"},
            { "Burnley", "Turf Moor"},
            { "Sunderland", "Stadium of Light"},
            { "Stoke City", "Britannia"},
            { "Aston Villa", "Villa Park"}
        };
    }
}